动态规划-leetcode53. Maximum Subarray

一、问题描述
Given an integer array nums, find the contiguous subarray (containing at least one number) which has the largest sum and return its sum.
Example:
Input: [-2,1,-3,4,-1,2,1,-5,4],
Output: 6
Explanation: [4,-1,2,1] has the largest sum = 6.

二、解决思路
思路一:暴力法,通过两下标求出每个子数组和并取最大,O(n^3)
思路二:动态规划法,分析思路一可以发现,暴力法存在很多重复计算,在终点下标加一的时候,如果当前值小于0时,直接可以舍弃该结果,因此,需要找到动态规划的状态转移方程,通过举例可以找到如下规律:
dp[i] = max(arr[i], dp[i - 1] + arr[i]),其中arr为元素数组,dp[i]为当前数组元素的最大子数组和,时空O(n)
思路三:对思路二的空间复杂度进行优化,题目只要求求出最大子数组和,可以通过两局部变量来替代数组,O(n)

三、算法实现
思路二

public int maxSubArray(int[] nums) {
        if (nums == null || nums.length == 0) {
            return 0;
        }
        int lens = nums.length;
        int[] dp = new int[lens];
        dp[0] = nums[0];
        int max = dp[0];
        for(int i = 1; i < lens; i++){
            dp[i] = Math.max(nums[i], dp[i - 1] + nums[i]);
            max = Math.max(max, dp[i]);
        }
        return max;
    }

思路三

public int maxSubArray(int[] nums) {
        if (nums == null || nums.length == 0) {
            return 0;
        }
        int lens = nums.length;
        int max = nums[0];
        int local = nums[0];
        for(int i = 1; i < lens; i++){
            local = Math.max(local + nums[i], nums[i]);
            max = Math.max(local, max);
        }
        return max;
    }

你可能感兴趣的:(动态规划-leetcode53. Maximum Subarray)